summaryrefslogtreecommitdiff
path: root/parabolaiso/initcpio/hooks/parabolaiso
diff options
context:
space:
mode:
Diffstat (limited to 'parabolaiso/initcpio/hooks/parabolaiso')
-rw-r--r--parabolaiso/initcpio/hooks/parabolaiso285
1 files changed, 0 insertions, 285 deletions
diff --git a/parabolaiso/initcpio/hooks/parabolaiso b/parabolaiso/initcpio/hooks/parabolaiso
deleted file mode 100644
index daac88b..0000000
--- a/parabolaiso/initcpio/hooks/parabolaiso
+++ /dev/null
@@ -1,285 +0,0 @@
-#!/bin/ash
-#
-# SPDX-License-Identifier: GPL-3.0-or-later
-
-# args: source, newroot, mountpoint
-_mnt_dmsnapshot() {
- local img="${1}"
- local newroot="${2}"
- local mnt="${3}"
- local img_fullname="${img##*/}";
- local img_name="${img_fullname%%.*}"
- local dm_snap_name="${dm_snap_prefix}_${img_name}"
- local ro_dev ro_dev_size rw_dev
-
- ro_dev="$(losetup --find --show --read-only -- "${img}")"
- echo "${ro_dev}" >> /run/parabolaiso/used_block_devices
- ro_dev_size="$(blockdev --getsz "${ro_dev}")"
-
- if [ "${cow_persistent}" = "P" ]; then
- if [ -f "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow" ]; then
- msg ":: Found '/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow', using as persistent."
- else
- msg ":: Creating '/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow' as persistent."
- truncate -s "${cow_spacesize}" "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow"
- fi
- else
- if [ -f "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow" ]; then
- msg ":: Found '/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow' but non-persistent requested, removing."
- rm -f "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow"
- fi
- msg ":: Creating '/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow' as non-persistent."
- truncate -s "${cow_spacesize}" "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow"
- fi
-
- rw_dev="$(losetup --find --show "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow")"
- echo "${rw_dev}" >> /run/parabolaiso/used_block_devices
-
- dmsetup create "${dm_snap_name}" --table \
- "0 ${ro_dev_size} snapshot ${ro_dev} ${rw_dev} ${cow_persistent} ${cow_chunksize}"
-
- if [ "${cow_persistent}" != "P" ]; then
- rm -f "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow"
- fi
-
- _mnt_dev "/dev/mapper/${dm_snap_name}" "${newroot}${mnt}" "-w" "defaults"
- readlink -f "/dev/mapper/${dm_snap_name}" >> /run/parabolaiso/used_block_devices
-}
-
-# args: source, newroot, mountpoint
-_mnt_overlayfs() {
- local src="${1}"
- local newroot="${2}"
- local mnt="${3}"
- mkdir -p "/run/parabolaiso/cowspace/${cow_directory}/upperdir" "/run/parabolaiso/cowspace/${cow_directory}/workdir"
- mount -t overlay -o \
- "lowerdir=${src},upperdir=/run/parabolaiso/cowspace/${cow_directory}/upperdir,workdir=/run/parabolaiso/cowspace/${cow_directory}/workdir" \
- airootfs "${newroot}${mnt}"
-}
-
-
-# args: /path/to/image_file, mountpoint
-_mnt_sfs() {
- local img="${1}"
- local mnt="${2}"
- local img_fullname="${img##*/}"
- local sfs_dev
-
- # shellcheck disable=SC2154
- # defined via initcpio's parse_cmdline()
- if [ "${copytoram}" = "y" ]; then
- msg -n ":: Copying squashfs image to RAM..."
-
- # in case we have pv use it to display copy progress feedback otherwise
- # fallback to using plain cp
- if command -v pv > /dev/null 2>&1; then
- echo ""
- (pv "${img}" > "/run/parabolaiso/copytoram/${img_fullname}")
- local rc=$?
- else
- (cp -- "${img}" "/run/parabolaiso/copytoram/${img_fullname}")
- local rc=$?
- fi
-
- if [ $rc != 0 ]; then
- echo "ERROR: while copy '${img}' to '/run/parabolaiso/copytoram/${img_fullname}'"
- launch_interactive_shell
- fi
-
- img="/run/parabolaiso/copytoram/${img_fullname}"
- msg "done."
- fi
- sfs_dev="$(losetup --find --show --read-only -- "${img}")"
- echo "${sfs_dev}" >> /run/parabolaiso/used_block_devices
- _mnt_dev "${sfs_dev}" "${mnt}" "-r" "defaults"
-}
-
-# args: /path/to/image_file, mountpoint
-_mnt_erofs() {
- local img="${1}"
- local mnt="${2}"
- local img_fullname="${img##*/}"
- local erofs_dev
-
- # shellcheck disable=SC2154
- # defined via initcpio's parse_cmdline()
- if [ "${copytoram}" = "y" ]; then
- msg -n ":: Copying EROFS image to RAM..."
- if ! cp -- "${img}" "/run/parabolaiso/copytoram/${img_fullname}" ; then
- echo "ERROR: while copy '${img}' to '/run/parabolaiso/copytoram/${img_fullname}'"
- launch_interactive_shell
- fi
- img="/run/parabolaiso/copytoram/${img_fullname}"
- msg "done."
- fi
- erofs_dev="$(losetup --find --show --read-only -- "${img}")"
- echo "${erofs_dev}" >> /run/parabolaiso/used_block_devices
- _mnt_dev "${erofs_dev}" "${mnt}" "-r" "defaults" "erofs"
-}
-
-# args: device, mountpoint, flags, opts
-_mnt_dev() {
- local dev="${1}"
- local mnt="${2}"
- local flg="${3}"
- local opts="${4}"
- local fstype="${5:-auto}"
-
- mkdir -p "${mnt}"
-
- msg ":: Mounting '${dev}' to '${mnt}'"
-
- while ! poll_device "${dev}" 30; do
- echo "ERROR: '${dev}' device did not show up after 30 seconds..."
- echo " Falling back to interactive prompt"
- echo " You can try to fix the problem manually, log out when you are finished"
- launch_interactive_shell
- done
-
- if mount -t "${fstype}" -o "${opts}" "${flg}" "${dev}" "${mnt}"; then
- msg ":: Device '${dev}' mounted successfully."
- else
- echo "ERROR; Failed to mount '${dev}'"
- echo " Falling back to interactive prompt"
- echo " You can try to fix the problem manually, log out when you are finished"
- launch_interactive_shell
- fi
-}
-
-_verify_checksum() {
- local _status
- cd "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}" || exit 1
- sha512sum -c airootfs.sha512 > /tmp/checksum.log 2>&1
- _status=$?
- cd -- "${OLDPWD}" || exit 1
- return "${_status}"
-}
-
-_verify_signature() {
- local _status
- local sigfile="${1}"
- cd "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}" || exit 1
- gpg --homedir /gpg --status-fd 1 --verify "${sigfile}" 2>/dev/null | grep -qE '^\[GNUPG:\] GOODSIG'
- _status=$?
- cd -- "${OLDPWD}" || exit 1
- return ${_status}
-}
-
-run_hook() {
- [ -z "${arch}" ] && arch="$(uname -m)"
- [ -z "${copytoram_size}" ] && copytoram_size="75%"
- [ -z "${parabolaisobasedir}" ] && parabolaisobasedir="parabola"
- [ -z "${dm_snap_prefix}" ] && dm_snap_prefix="parabola"
- # shellcheck disable=SC2154
- # defined via initcpio's parse_cmdline()
- [ -z "${parabolaisodevice}" ] && parabolaisodevice="/dev/disk/by-label/${parabolaisolabel}"
- [ -z "${cow_spacesize}" ] && cow_spacesize="256M"
- # shellcheck disable=SC2154
- # defined via initcpio's parse_cmdline()
- if [ -n "${cow_label}" ]; then
- cow_device="/dev/disk/by-label/${cow_label}"
- [ -z "${cow_persistent}" ] && cow_persistent="P"
- elif [ -n "${cow_device}" ]; then
- [ -z "${cow_persistent}" ] && cow_persistent="P"
- else
- cow_persistent="N"
- fi
-
- [ -z "${cow_flags}" ] && cow_flags="defaults"
- [ -z "${cow_directory}" ] && cow_directory="persistent_${parabolaisolabel}/${arch}"
- [ -z "${cow_chunksize}" ] && cow_chunksize="8"
-
- # set mount handler for parabolaiso
- export mount_handler="parabolaiso_mount_handler"
-}
-
-# This function is called normally from init script, but it can be called
-# as chain from other mount handlers.
-# args: /path/to/newroot
-parabolaiso_mount_handler() {
- local newroot="${1}"
- local sigfile
-
- if ! mountpoint -q "/run/parabolaiso/bootmnt"; then
- _mnt_dev "${parabolaisodevice}" "/run/parabolaiso/bootmnt" "-r" "defaults"
- if [ "${copytoram}" != "y" ]; then
- readlink -f "${parabolaisodevice}" >> /run/parabolaiso/used_block_devices
- fi
- fi
-
- # shellcheck disable=SC2154
- # defined via initcpio's parse_cmdline()
- if [ "${checksum}" = "y" ]; then
- if [ -f "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}/airootfs.sha512" ]; then
- msg -n ":: Self-test requested, please wait..."
- if _verify_checksum; then
- msg "done. Checksum is OK, continue booting."
- else
- echo "ERROR: one or more files are corrupted"
- echo "see /tmp/checksum.log for details"
- launch_interactive_shell
- fi
- else
- echo "ERROR: checksum=y option specified but ${parabolaisobasedir}/${arch}/airootfs.sha512 not found"
- launch_interactive_shell
- fi
- fi
-
- # shellcheck disable=SC2154
- # defined via initcpio's parse_cmdline()
- if [ "${verify}" = "y" ]; then
- if [ -f "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}/airootfs.sfs.sig" ]; then
- sigfile="airootfs.sfs.sig"
- elif [ -f "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}/airootfs.erofs.sig" ]; then
- sigfile="airootfs.erofs.sig"
- fi
- if [ -n "${sigfile}" ]; then
- msg -n ":: Signature verification requested, please wait..."
- if _verify_signature "${sigfile}"; then
- msg "done. Signature is OK, continue booting."
- else
- echo "ERROR: one or more files are corrupted"
- launch_interactive_shell
- fi
- else
- echo "ERROR: verify=y option specified but GPG signature not found in ${parabolaisobasedir}/${arch}/"
- launch_interactive_shell
- fi
- fi
-
- if [ "${copytoram}" = "y" ]; then
- msg ":: Mounting /run/parabolaiso/copytoram (tmpfs) filesystem, size=${copytoram_size}"
- mkdir -p /run/parabolaiso/copytoram
- mount -t tmpfs -o "size=${copytoram_size}",mode=0755 copytoram /run/parabolaiso/copytoram
- fi
-
- if [ -n "${cow_device}" ]; then
- _mnt_dev "${cow_device}" "/run/parabolaiso/cowspace" "-r" "${cow_flags}"
- readlink -f "${cow_device}" >> /run/parabolaiso/used_block_devices
- mount -o remount,rw "/run/parabolaiso/cowspace"
- else
- msg ":: Mounting /run/parabolaiso/cowspace (tmpfs) filesystem, size=${cow_spacesize}..."
- mkdir -p /run/parabolaiso/cowspace
- mount -t tmpfs -o "size=${cow_spacesize}",mode=0755 cowspace /run/parabolaiso/cowspace
- fi
- mkdir -p "/run/parabolaiso/cowspace/${cow_directory}"
- chmod 0700 "/run/parabolaiso/cowspace/${cow_directory}"
-
- if [ -f "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}/airootfs.sfs" ]; then
- _mnt_sfs "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}/airootfs.sfs" "/run/parabolaiso/airootfs"
- elif [ -f "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}/airootfs.erofs" ]; then
- _mnt_erofs "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}/airootfs.erofs" "/run/parabolaiso/airootfs"
- fi
- if [ -f "/run/parabolaiso/airootfs/airootfs.img" ]; then
- _mnt_dmsnapshot "/run/parabolaiso/airootfs/airootfs.img" "${newroot}" "/"
- else
- _mnt_overlayfs "/run/parabolaiso/airootfs" "${newroot}" "/"
- fi
-
- if [ "${copytoram}" = "y" ]; then
- umount -d /run/parabolaiso/bootmnt
- rmdir /run/parabolaiso/bootmnt
- fi
-}
-
-# vim: set ft=sh: